



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>非阻塞式JavaScript脚本介绍</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">非阻塞式JavaScript脚本介绍</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-17 23:21:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>JavaScript 倾向于阻塞浏览器某些处理过程，如HTTP 请求和界面刷新，这是开发者面临的最显著的性能问题。保持JavaScript文件短小，并限制HTTP请求的数量，只是创建反应迅速的网页应用的第一步。一个应用程序所包含的功能越多，所需要的JavaScript 代码就越大，保持源码短小并不总是一种选择。尽管下载一个大JavaScript 文件只产生一次HTTP 请求，却会锁定浏览器一大段时间。为避开这种情况，你需要向页面中逐步添加JavaScript，某种程度上说不会阻塞浏览器。非阻塞脚本的秘密在于，等页面完成加载之后，再加载JavaScript 源码。从技术角度讲，这意味着在window 的load 事件发出之后开始下载代码。有三种方法可以实现这种效果。</p>
<h4>延期脚本</h4>
<p>HTML 4 为&lt;script&gt;标签定义了一个扩展属性：defer。这个defer 属性指明元素中所包含的脚本不打算修改DOM，因此代码可以稍后执行。defer 属性只被Internet Explorer 4 和Firefox 3.5 更高版本的浏览器所支持，它不是一个理想的跨浏览器解决方案。在其他浏览器上，defer 属性被忽略，&lt;script&gt;标签按照默认方式被处理（造成阻塞）。如果浏览器支持的话，这种方法仍是一种有用的解决方案。示例如下：</p>
<pre class="prettyprint linenums">
&lt;script type="text/javascript" src="file1.js" defer&gt;&lt;/script&gt;
</pre>
<p>一个带有defer 属性的&lt;script&gt;标签可以放置在文档的任何位置。对应的JavaScript 文件将在&lt;script&gt;被解析时启动下载，但代码不会被执行，直到DOM 加载完成。（在onload 事件句柄被调用之前）。当一个defer的JavaScript 文件被下载时，它不会阻塞浏览器的其他处理过程，所以这些文件可以与页面的其他资源一起并行下载。任何带有defer 属性的&lt;script&gt;元素在DOM 加载完成之前不会被执行，不论是内联脚本还是外部脚本文件，都是这样。下面的例子展示了defer 属性如何影响脚本行为：</p>
<pre class="prettyprint linenums">

&lt;html&gt;<br />
      &lt;head&gt;<br />
            &lt;title&gt;Script Defer Example&lt;/title&gt;<br />
      &lt;/head&gt;<br />
      &lt;body&gt;<br />
            &lt;script defer&gt;<br />
                  alert("defer");<br />
            &lt;/script&gt;<br />
            &lt;script&gt;<br />
                  alert("script");<br />
            &lt;/script&gt;<br />
            &lt;script&gt;<br />
                  window.onload = function(){<br />
            alert("load");<br />
            };<br />
            &lt;/script&gt;<br />
      &lt;/body&gt;<br />
&lt;/html&gt;
</pre>
<p>这些代码在页面处理过程中弹出三个对话框。如果浏览器不支持defer 属性，那么弹出对话框的顺序是"defer"，"script"和"load"。如果浏览器支持defer 属性，那么弹出对话框的顺序是"script"，"defer"和"load"。注意，标记为defer 的&lt;script&gt;元素不是跟在第二个后面运行，而是在onload 事件句柄处理之前被调用。如果你的目标浏览器只包括Internet Explorer 和Firefox 3.5，那么defer 脚本确实有用。如果你需要支持跨领域的多种浏览器，那么还有更一致的实现方式。</p>
<h4>动态脚本元素</h4>
<p>文档对象模型（DOM）允许你使用JavaScript 动态创建HTML 的几乎全部文档内容。其根本在于，&lt;script&gt;元素与页面其他元素没有什么不同：引用变量可以通过DOM 进行检索，可以从文档中移动、删除，也可以被创建。一个新的&lt;script&gt;元素可以非常容易地通过标准DOM 函数创建：</p>
<pre class="prettyprint linenums">
var script = document.createElement ("script");<br />
   script.type = "text/javascript";<br />
   script.src = "file1.js";<br />
   document.getElementsByTagName_r("head")[0].appendChild(script);
</pre>
<p>新的&lt;script&gt;元素加载file1.js 源文件。此文件当元素添加到页面之后立刻开始下载。此技术的重点在于：无论在何处启动下载，文件的下载和运行都不会阻塞其他页面处理过程。你甚至可以将这些代码放在&lt;head&gt;部分而不会对其余部分的页面代码造成影响（除了用于下载文件的HTTP 连接）。</p>
<p>当文件使用动态脚本节点下载时，返回的代码通常立即执行（除了Firefox 和Opera，他们将等待此前的所有动态脚本节点执行完毕）。当脚本是"自运行"类型时这一机制运行正常，但是如果脚本只包含供页面其他脚本调用调用的接口，则会带来问题。这种情况下，你需要跟踪脚本下载完成并准备妥善的情况。可以使用动态&lt;script&gt;节点发出事件得到相关信息。</p>
<p>Firefox, Opera, Chorme 和Safari 3+会在&lt;script&gt;节点接收完成之后发出一个load 事件。你可以监听这一事件，以得到脚本准备好的通知：</p>
<pre class="prettyprint linenums">

var script = document.createElement ("script")<br />
   script.type = "text/javascript";<br />
   //Firefox, Opera, Chrome, Safari 3+<br />
         script.onload = function(){<br />
         alert("Script loaded!");<br />
   };<br />
   script.src = "file1.js";<br />
   document.getElementsByTagName("head")[0].appendChild(script);
</pre>
<p>Internet Explorer 支持另一种实现方式，它发出一个readystatechange 事件。&lt;script&gt;元素有一个readyState 属性，它的值随着下载外部文件的过程而改变。readyState 有五种取值：</p>
<ul><li>"uninitialized"默认状态</li>
<li>"loading"下载开始</li>
<li>"loaded"下载完成</li>
<li>"interactive"下载完成但尚不可用</li>
<li>"complete"所有数据已经准备好</li></ul>
<p>微软文档上说，在&lt;script&gt;元素的生命周期中，readyState 的这些取值不一定全部出现，但并没有指出哪些取值总会被用到。实践中，我们最感兴趣的是"loaded"和"complete"状态。Internet Explorer 对这两个readyState 值所表示的最终状态并不一致，有时&lt;script&gt;元素会得到"loader"却从不出现"complete"，但另外一些情况下出现"complete"而用不到"loaded"。最安全的办法就是在readystatechange 事件中检查这两种状态，并且当其中一种状态出现时，删除readystatechange 事件句柄（保证事件不会被处理两次）：</p>
<pre class="prettyprint linenums">

var script = document.createElement("script")<br />
   script.type = "text/javascript";<br />
   //Internet Explorer<br />
   script.onreadystatechange = function(){<br />
         if (script.readyState == "loaded" || script.readyState == "complete"){<br />
               script.onreadystatechange = null;<br />
               alert("Script loaded.");<br />
         }<br />
   };<br />
   script.src = "file1.js";<br />
   document.getElementsByTagName("head")[0].appendChild(script);
</pre>
<p>大多数情况下，你希望调用一个函数就可以实现JavaScript 文件的动态加载。下面的函数封装了标准实现和IE 实现所需的功能：</p>
<pre class="prettyprint linenums">

function loadScript(url, callback){<br />
           var script = document.createElement ("script")<br />
           script.type = "text/javascript";<br />
           if (script.readyState){ //IE<br />
                 script.onreadystatechange = function(){<br />
                       if (script.readyState == "loaded" || script.readyState == "complete"){<br />
                             script.onreadystatechange = null;<br />
                             callback();<br />
                       }<br />
                };<br />
           } else { //Others<br />
                 script.onload = function(){<br />
                 callback();<br />
           };<br />
     }<br />
     script.src = url;<br />
     document.getElementsByTagName("head")[0].appendChild(script);<br />
     }
</pre>
<p>此函数接收两个参数：JavaScript 文件的URL，和一个当JavaScript 接收完成时触发的回调函数。属性检查用于决定监视哪种事件。最后一步，设置src 属性，并将&lt;script&gt;元素添加至页面。此loadScript()函数使用方法如下：</p>
<pre class="prettyprint linenums">
loadScript("file1.js", function(){<br />
           alert("File is loaded!");<br />
     });
</pre>
<p>你可以在页面中动态加载很多JavaScript 文件，但要注意，浏览器不保证文件加载的顺序。所有主流浏览器之中，只有Firefox 和Opera 保证脚本按照你指定的顺序执行。其他浏览器将按照服务器返回它们的次序下载并运行不同的代码文件。你可以将下载操作串联在一起以保证他们的次序，如下：</p>
<pre class="prettyprint linenums">

loadScript("file1.js", function(){<br />
           loadScript("file2.js", function(){<br />
                 loadScript("file3.js", function(){<br />
                       alert("All files are loaded!");<br />
                 });<br />
           });<br />
     });
</pre>
<p>此代码等待file1.js 可用之后才开始加载file2.js，等file2.js 可用之后才开始加载file3.js。虽然此方法可行，但如果要下载和执行的文件很多，还是有些麻烦。如果多个文件的次序十分重要，更好的办法是将这些文件按照正确的次序连接成一个文件。独立文件可以一次性下载所有代码（由于这是异步进行的，使用一个大文件并没有什么损失）。</p>
<p>动态脚本加载是非阻塞JavaScript 下载中最常用的模式，因为它可以跨浏览器，而且简单易用。</p>
<h4>使用XMLHttpRequest(XHR)对象</h4>
<p>此技术首先创建一个XHR 对象，然后下载JavaScript 文件，接着用一个动态&lt;script&gt;元素将JavaScript 代码注入页面。下面是一个简单的例子：</p>
<pre class="prettyprint linenums">

var xhr = new XMLHttpRequest();<br />
   xhr.open("get", "file1.js", true);<br />
   xhr.onreadystatechange = function(){<br />
         if (xhr.readyState == 4){<br />
               if (xhr.status &gt;= 200 &amp;&amp; xhr.status &lt; 300 || xhr.status == 304){<br />
                     var script = document.createElement ("script");<br />
                     script.type = "text/javascript";<br />
                     script.text = xhr.responseText;<br />
                     document.body.appendChild(script);<br />
               }<br />
         }<br />
   };<br />
   xhr.send(null);
</pre>
<p>此代码向服务器发送一个获取file1.js 文件的GET 请求。onreadystatechange 事件处理函数检查readyState是不是4，然后检查HTTP 状态码是不是有效（2XX 表示有效的回应，304 表示一个缓存响应）。如果收到了一个有效的响应，那么就创建一个新的&lt;script&gt;元素，将它的文本属性设置为从服务器接收到的responseText 字符串。这样做实际上会创建一个带有内联代码的&lt;script&gt;元素。一旦新&lt;script&gt;元素被添加到文档，代码将被执行，并准备使用。这种方法的主要优点是，你可以下载不立即执行的JavaScript 代码。由于代码返回在&lt;script&gt;标签之外（换句话说不受&lt;script&gt;标签约束），它下载后不会自动执行，这使得你可以推迟执行，直到一切都准备好了。另一个优点是，同样的代码在所有现代浏览器中都不会引发异常。此方法最主要的限制是：JavaScript 文件必须与页面放置在同一个域内，不能从CDNs 下载（CDN 指"内容投递网络（Content Delivery Network）"，大型网页通常不采用XHR 脚本注入技术。</p>
<p>推荐的向页面加载大量JavaScript 的方法分为两个步骤：第一步，包含动态加载JavaScript 所需的代码，然后加载页面初始化所需的除JavaScript 之外的部分。这部分代码尽量小，可能只包含loadScript()函数，它下载和运行非常迅速，不会对页面造成很大干扰。当初始代码准备好之后，用它来加载其余的JavaScript。例如：</p>
<pre class="prettyprint linenums">
&lt;script type="text/javascript" src="loader.js"&gt;&lt;/script&gt;<br />
   &lt;script type="text/javascript"&gt;<br />
         loadScript("the-rest.js", function(){<br />
               Application.init();<br />
         });<br />
   &lt;/script&gt;
</pre>
<p>将此代码放置在body 的关闭标签&lt;/body&gt;之前。这样做有几点好处：首先，像前面讨论过的那样，这样做确保JavaScript 运行不会影响页面其他部分显示。其次，当第二部分JavaScript 文件完成下载，所有应用程序所必须的DOM 已经创建好了，并做好被访问的准备，避免使用额外的事件处理（例如window.onload）来得知页面是否已经准备好了。另一个选择是直接将loadScript()函数嵌入在页面中，这可以避免另一次HTTP 请求。例如：</p>
<pre class="prettyprint linenums">

&lt;script type="text/javascript"&gt;<br />
         function loadScript(url, callback){<br />
               var script = document.createElement ("script")<br />
               script.type = "text/javascript";<br />
               if (script.readyState){ //IE<br />
                     script.onreadystatechange = function(){<br />
                           if (script.readyState == "loaded" ||<br />
                           script.readyState == "complete"){<br />
                                 script.onreadystatechange = null;<br />
                                 callback();<br />
                           }<br />
                     };<br />
               } else { //Others<br />
                     script.onload = function(){<br />
                     callback();<br />
                     };<br />
               }<br />
               script.src = url;<br />
               document.getElementsByTagName_r("head")[0].appendChild(script);<br />
         }<br />
         loadScript("the-rest.js", function(){<br />
               Application.init();<br />
         });<br />
   &lt;/script&gt;
</pre>
<p>如果你决定使用这种方法，建议你使用''YUI Compressor''或者类似的工具将初始化脚本缩小到最小字节尺寸。一旦页面初始化代码下载完成，你还可以使用loadScript()函数加载页面所需的额外功能函数。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlmg5k9.html">Oracle下批量将一个用户的所有表的select权限赋值给另外一个用户</a>
		</li>
						<li><a href="https://www.batexi.com/a/m960nd49.html">MySQL入门01-MySQL源码安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rkmkeq.html">jquery层级原则器（匹配前一个元素后的下一个元素，必须是挨着的）</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rpxo48.html">lua 获取文件名和扩展名</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq416req.html">dyld&colon; Library not loaded&colon; &sol;System&sol;Library&sol;Frameworks&sol;UserNotifications&period;framework&sol;UserNotifications解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql63j1q.html">Handler与Looper，MessageQueue的关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mg0p28.html">Unicode编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1k7239.html">windows phone 豆瓣api的封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m5o5jq.html">Solr In Action 笔记&lpar;3&rpar; 之 SolrCloud基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg6om78.html">VB&period;net shell、IO&period;File&period;Open、Process&period;Start、Shellexecute API 运用经验总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj2doe9.html">word文档的动态添加数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zrx5n9.html">网络流 之 dinic算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gel1348.html">烦神的斐波那契&amp;amp&semi;&amp;amp&semi;洛谷-1306-斐波那契公约数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvvrw28.html">The JRE&lowbar;HOME environment variable is not defined correctly This environment</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r4n7z8.html">什么是CONTAINERD？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o13wj1q.html">vue实现淘宝购物车功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd353j9.html">vue子组件，同级组件之间的相互引用，以及传值交互</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25o1nlq.html">&num;define宏重定义</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjjpw08.html">字符串过滤掉所有最邻近的&OpenCurlyDoubleQuote;&amp;lt&semi;&rdquo;和&OpenCurlyDoubleQuote;&amp;gt&semi;&rdquo;之间的字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/8konjy3q.html">使用 MtVerify&period;h头文件 ，用的时候把他头文件的内容添加到项目</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2wkepxq.html">db2新建数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wk1mlq.html">hdu 5183 Negative and Positive &lpar;NP&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xp2pz9.html">System&period;IO之内存映射文件共享内存</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvveyoxq.html">&lpar;转&rpar;android Fragments详解三&colon;实现Fragment的界面</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o3rrn9.html">power tool 强制撤销</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnj0v6q.html">如何在Quartus II中设置Virtual pin</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0m5vgq.html">状压DP</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1np3j8.html">Oracle数据文件在open状态被删除的恢复记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x34068.html">C&plus;&plus;中不可重载的5个运算符</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdl10y8.html">python中fork&lpar;&rpar;函数生成子进程分析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
